<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link href="common/css/sf.css" rel="stylesheet" type="text/css" />
<title>Bib: Bibliography</title>
<link href="common/jquery-ui/jquery-ui.css" rel="stylesheet">
<script src="common/jquery-ui/external/jquery/jquery.js"></script>
<script src="common/jquery-ui/jquery-ui.js"></script>
<script src="common/toggleproofs.js"></script>
<link href="common/css/slf.css" rel="stylesheet" type="text/css"/>
</head>

<body>

<div id="page">

<div id="header">
<div id='logoinheader'><a href='https://softwarefoundations.cis.upenn.edu'>
<img src='common/media/image/sf_logo_sm.png' alt='Software Foundations Logo'></a></div>
<div class='booktitleinheader'><a href='index.html'>Volume 6: Separation Logic Foundations</a></div>
<ul id='menu'>
   <li class='section_name'><a href='toc.html'>Table of Contents</a></li>
   <li class='section_name'><a href='coqindex.html'>Index</a></li>
   <li class='section_name'><a href='deps.html'>Roadmap</a></li>
</ul>
</div>

<div id="main">

<h1 class="libtitle">Bib<span class="subtitle">Bibliography</span></h1>


<div class="doc">

<div class="paragraph"> </div>

<a id="lab509"></a><h1 class="section">Resources cited in this volume</h1>

<div class="paragraph"> </div>

 An extended related work section on the history of Separation Logic
    may be found in the paper <a target="Charguéraud-2020"><span class="inlineref"><b>[Charguéraud 2020]</b></span></a>, available from:
    <a href='http://www.chargueraud.org/research/2020/seq_seplogic/seq_seplogic.pdf'>http://www.chargueraud.org/research/2020/seq_seplogic/seq_seplogic.pdf</a>

<div class="paragraph"> </div>

    The references most relevant to the contents of the course appear below. 
<div class="paragraph"> </div>


<div class="paragraph"> </div>

<a target="Birkedal,-Torp-Smith and Yang 2006"><span class="inlineref"><b>[Birkedal, Torp-Smith and Yang 2006]</b></span></a>
   Lars Birkedal, Noah Torp-smith, and Hongseok Yang.
   Semantics of separation-logic typing and higher-order frame rules
    for algol-like languages.
   In Logical Methods in Computer Science.

<div class="paragraph"> </div>

<a target="Burstall-1972"><span class="inlineref"><b>[Burstall 1972]</b></span></a>
   R. M. Burstall.
   Some Techniques for Proving Correctness of Programs which Alter Data
     Structures.
   In Machine Intelligence 7, Edinburgh University Press.

<div class="paragraph"> </div>

<a target="Charguéraud-2010"><span class="inlineref"><b>[Charguéraud 2010]</b></span></a>
  Arthur Charguéraud.
  Characteristic Formulae for Mechanized Program Verification.
  PhD thesis, Université Paris Diderot, December 2010.

<div class="paragraph"> </div>

<a target="Charguéraud-2011"><span class="inlineref"><b>[Charguéraud 2011]</b></span></a>
  Arthur Charguéraud.
  Characteristic Formulae for the Verification of Imperative Programs.
  In International Conference on Functional Programming (ICFP).
  <a href='https://doi.org/10.1145/2034773.2034828'>https://doi.org/10.1145/2034773.2034828</a>

<div class="paragraph"> </div>

<a target="Charguéraud-2020"><span class="inlineref"><b>[Charguéraud 2020]</b></span></a>
  Arthur Charguéraud.
  Separation Logic for Sequential Programs.
  In Internation Conference on Function Programming (ICFP).
  <a href='https://dl.acm.org/doi/abs/10.1145/3408998'>https://dl.acm.org/doi/abs/10.1145/3408998</a>

<div class="paragraph"> </div>

<a target="Charguéraud-et al 2022"><span class="inlineref"><b>[Charguéraud et al 2022]</b></span></a>
  Arthur Charguéraud, Adam Chlipala, Andres Erbsen, and Samuel Gruetter.
  Omnisemantics: Smoother Handling of Nondeterminism (Draft).
  <a href='http://www.chargueraud.org/research/2022/omnisemantics/omnisemantics.pdf.'>http://www.chargueraud.org/research/2022/omnisemantics/omnisemantics.pdf.</a>

<div class="paragraph"> </div>

<a target="Chlipala-et al 2009"><span class="inlineref"><b>[Chlipala et al 2009]</b></span></a>
  Adam Chlipala, Gregory Malecha, Greg Morrisett, Avraham Shinnar,
   and Ryan Wisnesky.
  Effective Interactive Proofs for Higher-Order Imperative Programs.
  In International Conference on Functional Programming (ICFP).
  <a href='https://doi.org/10.1145/1596550.'>https://doi.org/10.1145/1596550.</a>
  See also the other papers: <a href='https://ynot.cs.harvard.edu/'>https://ynot.cs.harvard.edu/</a>

<div class="paragraph"> </div>

<a target="Guéneau,-Jourdan, Charguéraud, and Pottier 2019"><span class="inlineref"><b>[Guéneau, Jourdan, Charguéraud, and Pottier 2019]</b></span></a>
  Armaël Guéneau, Jacques-Henri Jourdan, Arthur Charguéraud,
   and François Pottier.
  Formal Proof and Analysis of an Incremental Cycle Detection Algorithm.
  In Interactive Theorem Proving (ITP).
  <a href='https://doi.org/10.4230/LIPIcs.ITP.2019.18'>https://doi.org/10.4230/LIPIcs.ITP.2019.18</a>

<div class="paragraph"> </div>

<a target="Guéneau,-Myreen, Kumar and Norrish 2017"><span class="inlineref"><b>[Guéneau, Myreen, Kumar and Norrish 2017]</b></span></a>
  Armaël Guéneau, Magnus O. Myreen, Ramana Kumar, and Michael Norrish.
  Verified Characteristic Formulae for CakeML.
  In European Symposium on Programming (ESOP).
  <a href='https://doi.org/10.1007/978-3-662-54434-1_22'>https://doi.org/10.1007/978-3-662-54434-1_22</a>

<div class="paragraph"> </div>

<a target="Dijstra-1975"><span class="inlineref"><b>[Dijstra 1975]</b></span></a>
  Edsger W. Dijkstra.
  Guarded commands, nondeterminacy and formal derivation of programs.
  Communications of the ACM.
  <a href='https://doi.org/10.1145/360933.360975'>https://doi.org/10.1145/360933.360975</a>

<div class="paragraph"> </div>

<a target="Gordon-1989"><span class="inlineref"><b>[Gordon 1989]</b></span></a>
  Michael J. C. Gordon.
  Mechanizing Programming Logics in Higher Order Logic.
  Springer-Verlag, Berlin, Heidelberg,
  <a href='https://doi.org/10.1007/978-1-4612-3658-0_10'>https://doi.org/10.1007/978-1-4612-3658-0_10</a>

<div class="paragraph"> </div>

<a target="Krishnaswami,-Birkedal, and Aldrich 2010"><span class="inlineref"><b>[Krishnaswami, Birkedal, and Aldrich 2010]</b></span></a>
  Neel R. Krishnaswami, Lars Birkedal, and Jonathan Aldrich.
  Verifying Event-Driven Programs Using Ramified Frame Properties.
  In Workshop on Types in Language Design and Implementation (TLDI).
  <a href='https://doi.org/10.1145/1708016.1708025'>https://doi.org/10.1145/1708016.1708025</a>

<div class="paragraph"> </div>

<a target="Hennessy-and Milner 1985"><span class="inlineref"><b>[Hennessy and Milner 1985]</b></span></a>
  Matthew Hennessy and Robin Milner.
  Algebraic laws for nondeterminism and concurrency.
  Journal of the ACM, 32.
  <a href='https://dl.acm.org/doi/10.1145/2455.2460'>https://dl.acm.org/doi/10.1145/2455.2460</a>

<div class="paragraph"> </div>

<a target="Honda,-Berger, and Yoshida 2006"><span class="inlineref"><b>[Honda, Berger, and Yoshida 2006]</b></span></a>
  Kohei Honda, Martin Berger, and Nobuko Yoshida.
  Descriptive and relative completeness of logics for higher-order functions.
  International Colloquium on Automata, Languages and Programming (ICALP).
  <a href='https://doi.org/10.1007/11787006_31'>https://doi.org/10.1007/11787006_31</a>

<div class="paragraph"> </div>

<a target="Hobor-and Villard 2013"><span class="inlineref"><b>[Hobor and Villard 2013]</b></span></a>
  Aquinas Hobor and Jules Villard.
  The Ramifications of Sharing in Data Structures.
  In Symposium on Principles of Programming Languages (POPL).
  <a href='https://doi.org/10.1145/2429069.2429131'>https://doi.org/10.1145/2429069.2429131</a>

<div class="paragraph"> </div>

<a target="Ishtiaq-and O'Hearn 2001"><span class="inlineref"><b>[Ishtiaq and O'Hearn 2001]</b></span></a>
  Samin S. Ishtiaq and Peter W. O’Hearn.
  BI as an Assertion Language for Mutable Data Structures.
  SIGPLAN Notice 36.
  <a href='https://doi.org/10.1145/373243.375719'>https://doi.org/10.1145/373243.375719</a>

<div class="paragraph"> </div>

<a target="Jung-et al 2018"><span class="inlineref"><b>[Jung et al 2018]</b></span></a>
  Ralf Jung, Robbert Krebbers, Jacques-Henri Jourdan, Ale{\v{s<span style='letter-spacing:-.4em;'>}</span>} Bizjak,
   Lars Birkedal, Derek Dreyer.
  Iris from the ground up: A modular foundation for higher-order concurrent
   separation logic.
  Journal of Functional Programming.
  <a href='https://doi.org/10.1017/S0956796818000151'>https://doi.org/10.1017/S0956796818000151</a>

<div class="paragraph"> </div>

<a target="O'Hearn-and Pym 1999"><span class="inlineref"><b>[O'Hearn and Pym 1999]</b></span></a>
  Peter W. O’Hearn and David J. Pym.
  The Logic of Bunched Implications.
  The Bulletin of Symbolic Logic 5.
  <a href='https://doi.org/10.2307/421090'>https://doi.org/10.2307/421090</a>

<div class="paragraph"> </div>

<a target="O'Hearn,-Reynolds, and Yang 2001"><span class="inlineref"><b>[O'Hearn, Reynolds, and Yang 2001]</b></span></a>
  Peter W. O’Hearn, John C. Reynolds, and Hongseok Yang.
  Local Reasoning about Programs that Alter Data Structures.
  Workshop on Computer Science Logic (CSL).
  <a href='https://doi.org/10.1007/3-540-44802-0_1'>https://doi.org/10.1007/3-540-44802-0_1</a>

<div class="paragraph"> </div>

<a target="Reynolds-2002"><span class="inlineref"><b>[Reynolds 2002]</b></span></a>
  John C. Reynolds.
  Separation Logic: A Logic for Shared Mutable Data Structures.
  Annual IEEE Symposium on Logic in Computer Science (LICS).
  10.1109/LICS.2002.1029817

<div class="paragraph"> </div>

<a target="Reynolds-2000"><span class="inlineref"><b>[Reynolds 2000]</b></span></a>
  John C. Reynolds.
  Intuitionistic Reasoning about Shared Mutable Data Structure
  <a href='http://citeseerx.ist.psu.edu/viewdoc/download?doi=10.1.1.11.5999&amp;rep=rep1&amp;type=pdf'>http://citeseerx.ist.psu.edu/viewdoc/download?doi=10.1.1.11.5999&amp;rep=rep1&amp;type=pdf</a>

<div class="paragraph"> </div>

<a target="Schäfer-et al 2016"><span class="inlineref"><b>[Schäfer et al 2016]</b></span></a>
  Steven Schäfer, Sigurd Schneider, Gert Smolka.
  Axiomatic Semantics for Compiler Verification.
  In Conference on Certified Programs and Proofs (CPP).
  <a href='https://dl.acm.org/doi/10.1145/2854065.2854083'>https://dl.acm.org/doi/10.1145/2854065.2854083</a>

<div class="paragraph"> </div>

<a target="Tuerk-2010"><span class="inlineref"><b>[Tuerk 2010]</b></span></a>
  Thomas Tuerk.
  Local Reasoning about While-Loops.
  In International Conference on Verified Software: Theories, Tools and
   Experiments (VSTTE).

<div class="paragraph"> </div>

<a target="Weber-2004"><span class="inlineref"><b>[Weber 2004]</b></span></a>
  Tjark Weber.
  Towards Mechanized Program Verification with Separation Logic.
  In Computer Science Logic (CSL)
  <a href='https://doi.org/10.1007/978-3-540-30124-0_21'>https://doi.org/10.1007/978-3-540-30124-0_21</a>

<div class="paragraph"> </div>

<a target="Yu,-Hamid, and Shao 2003"><span class="inlineref"><b>[Yu, Hamid, and Shao 2003]</b></span></a>
  Dachuan Yu, Nadeem A. Hamid, and Zhong Shao.
  Building Certified Libraries for PCC: Dynamic Storage Allocation.
  European Symposium on Programming (ESOP).
  <a href='https://doi.org/10.1007/3-540-36575-3_25'>https://doi.org/10.1007/3-540-36575-3_25</a>

<div class="paragraph"> </div>


<div class="paragraph"> </div>

  
</div>
<div class="code">

<span class="comment">(*&nbsp;2023-03-25&nbsp;11:36&nbsp;*)</span><br/>
</div>
</div>

<div id="footer">
<hr/><a href="coqindex.html">Index</a><hr/>This page has been generated by <a href="http://coq.inria.fr/">coqdoc</a>
</div>

</div>

</body>
</html>